/*
Servotester with Arduino Mini Pro

Modified from some internet file :-)

Servo output = pin 2

Run button = pin 5
Minus button = pin 4
Plus button = pin 3
buttons between GND and pin, pull-up resistors 10k to +5V

RUN LED = pin 10
MINUS LED = pin 11
PLUS LED = pin 12

Display Banggood SSD1306 0.96" OLED I2C 
SDA = Pin A4
SCL = PIN A5


Status indication in binary code:
Mode    MINUS LED   PLUS LED   
0       0           0
1       0           1
2       1           0
3       1           1

Mode 0
Manual servo control with step 1% from -100% to +100%

Mode 1
Servo cycling contiously from -100% to +100% and back with step 1% to 10%

Mode 2
Servo cycling from -100% to +100% contiously and jump to -100%

Mode 3
Servo jumps -100% to 0% to +100% and back with variable jump delay 0.4 to 9.9s.

7. February 2017
ddano007@rcmodelytt.sk
*/

#include <Servo.h>
#include "U8glib.h"  //https://code.google.com/p/u8glib/
#include <OneWire.h>


Servo myservo;  // create servo object to control a servo

U8GLIB_SSD1306_128X64_2X u8g(U8G_I2C_OPT_NONE);     //Banggood SSD1306 0.96" OLED I2C     http://www.banggood.com/0_96-Inch-White-IIC-I2C-OLED-Display-Module-12864-LED-For-Arduino-p-932606.html
                                                       //SDA = Pin A4 ; SCL = PIN A5


int val= 0;    
int outservo = 100;  
int smer= 2;  // direction up  or down
int RunLed = 10;
int MinusLed = 11; 
int PlusLed = 12;
int RunButton = 5; 
int MinusButton = 4; 
int PlusButton = 3; 
int RunStatus = 0;     // 0 = stop, 1 = run
int RunButtonStatus = 1;  
int RunButtonStatusOld = 1;  
int MinusButtonStatus = 1;  
int MinusButtonStatusOld = 1;   
int PlusButtonStatus = 1; 
int PlusButtonStatusOld = 1;
int ServoMode = 0       ; 
int Zmena = 0       ; 
int Step = 1       ;  
int StepDefault = 1       ; 
int ValStep = 1       ;  
int MinStep = 1       ;   
int MaxStep = 10       ;  
float SSSval = 1.2       ;  
unsigned long SSSCycleDefault = 500 ; // SSS perioda 500ms
unsigned long SSSCycleStep = 200 ; // Krok SSS periody 200ms
unsigned long SSSCycleMin = 300 ; // Minimalna SSS perioda 300ms
unsigned long SSSCycleMax = 9900 ; // Maxmalna SSS perioda 9.9s
unsigned long SSSCycle ; // SSS perioda
unsigned long AktualTime = millis();
unsigned long ClickTime  ;
unsigned long FirstClickDefault = 600  ;
unsigned long NextClickDefault = 0  ;
unsigned long KeyboardTime  ;
unsigned long KeyboardTimeDefault = 60  ;// 60ms snimanie klavesnice


  void u8g_prepare(void)                //priprava displeja
  {
  //u8g.setFont(u8g_font_6x10);
  //u8g.setFont(u8g_font_fub42n);
  //u8g.setFontRefHeightExtendedText();
  //u8g.setDefaultForegroundColor();
  //u8g.setFontPosTop();
  }



void setup() {
  myservo.attach(2);  // attaches the servo on pin 2 to the servo object
  pinMode(LED_BUILTIN, OUTPUT);
  myservo.writeMicroseconds(1500);  // set servo to mid-point
  pinMode(RunLed, OUTPUT);  // declare LED as output
  pinMode(MinusLed, OUTPUT);  // declare LED as output
  pinMode(PlusLed, OUTPUT);  // declare LED as output
  pinMode(RunButton, INPUT);    // declare pushbutton as input
  pinMode(MinusButton, INPUT);    // declare pushbutton as input
  pinMode(PlusButton, INPUT);    // declare pushbutton as input

    digitalWrite(RunLed, HIGH);  // turn LED OFF
    digitalWrite(MinusLed, HIGH);  // turn LED OFF
    digitalWrite(PlusLed, HIGH);  // turn LED OFF

  u8g.setContrast(0x30);
  u8g_prepare(); 


  u8g.firstPage();

   do {
 
    u8g.setFont(u8g_font_fub17);
    u8g.drawStr( 0, 18, "Servotester");
    u8g.drawStr( 0, 38, "on Arduino");
    u8g.drawStr( 0, 58, " ddano007");
    } while( u8g.nextPage() );

 
  delay (3000);
  Zmena++;
  KeyboardTime = millis() + KeyboardTimeDefault  ;




}

void loop() {


  AktualTime = millis();


  if ( KeyboardTime <= AktualTime )
  {

    KeyboardTime = AktualTime + KeyboardTimeDefault  ;

    //Tlacidlo RUN
    RunButtonStatus = digitalRead(RunButton);  // read input value

    if (RunButtonStatus == LOW & RunButtonStatusOld == HIGH)
      {
      RunStatus++;
      Zmena++;
      }
      if (RunStatus == 2)
        RunStatus = 0;

     RunButtonStatusOld = RunButtonStatus;

    //Tlacidlo MINUS
    MinusButtonStatus = digitalRead(MinusButton);  // read input value

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == HIGH & RunStatus == 0 )
      {
      ServoMode--;
      Zmena++;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 0)
      {
      val--;
      Zmena++;
      if (val <= -100)
        val = -100;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 0 & AktualTime > ClickTime )
      {
      val = 10 * ( val/10 ) - 10;
      Zmena++;
      if (val <= -100)
        val = -100;
      ClickTime = AktualTime + NextClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 1)
      {
      Step = Step - ValStep;
      Zmena++;
      if (Step <= MinStep)
        Step = MinStep;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 1 & AktualTime > ClickTime )
      {
      Step = Step - ValStep;
      Zmena++;
      if (Step <= MinStep)
        Step = MinStep;
      ClickTime = AktualTime + NextClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 2)
      {
      Step = Step - ValStep;
      Zmena++;
      if (Step <= MinStep)
        Step = MinStep;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 2 & AktualTime > ClickTime )
      {
      Step = Step - ValStep;
      Zmena++;
      if (Step <= MinStep)
        Step = MinStep;
      ClickTime = AktualTime + NextClickDefault ;
      }


    if (MinusButtonStatus == LOW & MinusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 3)
      {
      SSSCycleDefault = SSSCycleDefault - SSSCycleStep;
      Zmena++;
      if (SSSCycleDefault <= SSSCycleMin)
        SSSCycleDefault = SSSCycleMin;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (MinusButtonStatus == LOW & MinusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 3 & AktualTime > ClickTime )
      {
      SSSCycleDefault = SSSCycleDefault - SSSCycleStep;
      Zmena++;
      if (SSSCycleDefault <= SSSCycleMin)
        SSSCycleDefault = SSSCycleMin;
      ClickTime = AktualTime + NextClickDefault ;
      }

     MinusButtonStatusOld = MinusButtonStatus;

    //Tlacidlo PLUS
    PlusButtonStatus = digitalRead(PlusButton);  // read input value

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == HIGH & RunStatus == 0 )
      {
      ServoMode++;
      Zmena++;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 0)
      {
      val++;
      Zmena++;
      if (val >= +100)
        val = +100;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 0 & AktualTime > ClickTime )
      {
      val = 10 * ( val/10 ) + 10;
      Zmena++;
      if (val >= +100)
        val = +100;
      ClickTime = AktualTime + NextClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 1)
      {
      Step = Step + ValStep;
      Zmena++;
      if (Step >= MaxStep)
        Step = MaxStep;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 1 & AktualTime > ClickTime )
      {
      Step = Step + ValStep;
      Zmena++;
      if (Step >= MaxStep)
        Step = MaxStep;
      ClickTime = AktualTime + NextClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 2)
      {
      Step = Step + ValStep;
      Zmena++;
      if (Step >= MaxStep)
        Step = MaxStep;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 2 & AktualTime > ClickTime )
      {
      Step = Step + ValStep;
      Zmena++;
      if (Step >= MaxStep)
        Step = MaxStep;
      ClickTime = AktualTime + NextClickDefault ;
      }


    if (PlusButtonStatus == LOW & PlusButtonStatusOld == HIGH & RunStatus == 1 & ServoMode == 3)
      {
      SSSCycleDefault = SSSCycleDefault + SSSCycleStep;
      Zmena++;
      if (SSSCycleDefault >= SSSCycleMax)
        SSSCycleDefault = SSSCycleMax;
      ClickTime = AktualTime + FirstClickDefault ;
      }

    if (PlusButtonStatus == LOW & PlusButtonStatusOld == LOW & RunStatus == 1 & ServoMode == 3 & AktualTime > ClickTime )
      {
      SSSCycleDefault = SSSCycleDefault + SSSCycleStep;
      Zmena++;
      if (SSSCycleDefault >= SSSCycleMax)
        SSSCycleDefault = SSSCycleMax;
      ClickTime = AktualTime + NextClickDefault ;
      }

     
     PlusButtonStatusOld = PlusButtonStatus;



    if (ServoMode < 0)
        ServoMode = 3;
    if (ServoMode > 3)
        ServoMode = 0;

    SSSval = (float)SSSCycleDefault / 1000.0;

  if (Zmena > 0)
  {
  u8g.firstPage();

  do {

     u8g.setFont(u8g_font_fub17);

    if (ServoMode == 0)
    u8g.drawStr( 0, 18, "..Mode 0..");
    if (ServoMode == 1)
    u8g.drawStr( 0, 18, "..Mode 1..");
    if (ServoMode == 2)
    u8g.drawStr( 0, 18, "..Mode 2..");
    if (ServoMode == 3)
    u8g.drawStr( 0, 18, "..Mode 3..");

    if (ServoMode == 0)
    u8g.drawStr( 0, 38, "  Manual");
    if (ServoMode == 1)
    u8g.drawStr( 0, 38, "Slow-Slow");
    if (ServoMode == 2)
    u8g.drawStr( 0, 38, "Slow-Quick");
    if (ServoMode == 3)
    u8g.drawStr( 0, 38, "S-S-Step");

   
    u8g.setFont(u8g_font_fub17n);
    u8g.setPrintPos(0, 58);
    if ( RunStatus == 1 & ServoMode == 0 )
        u8g.print(val);
    if ( RunStatus == 1 & ServoMode == 1 )
        u8g.print(Step);
    if ( RunStatus == 1 & ServoMode == 2 )
        u8g.print(Step);
    if ( RunStatus == 1 & ServoMode == 3 )
        u8g.print(SSSval);
    u8g.setFont(u8g_font_fub17);

    if (RunStatus == 0 & val == 0)
    u8g.drawStr( 0, 58, "**STOP**");

    if (RunStatus == 0 & val != 0)
    u8g.drawStr( 0, 58, "**Wait**");

    if (RunStatus == 1 & ServoMode == 0)
    u8g.drawStr( 55 , 58, "% Run");

    if (RunStatus == 1 & ServoMode == 1)
    u8g.drawStr( 55 , 58, "k Run");

    if (RunStatus == 1 & ServoMode == 2)
    u8g.drawStr( 55 , 58, "k Run");

    if (RunStatus == 1 & ServoMode == 3)
    u8g.drawStr( 55 , 58, "s Run");

    } while( u8g.nextPage() );

    

  }

  if (Zmena > 0)
  {
    if (ServoMode == 0)
    {
    digitalWrite(MinusLed, HIGH);  // turn LED OFF
    digitalWrite(PlusLed, HIGH);  // turn LED OFF
    Step = StepDefault;
    }
    if (ServoMode == 1)
    {
    digitalWrite(MinusLed, HIGH);  // turn LED OFF
    digitalWrite(PlusLed, LOW);  // turn LED OFF
    }
    if (ServoMode == 2)
    {
    digitalWrite(MinusLed, LOW);  // turn LED OFF
    digitalWrite(PlusLed, HIGH);  // turn LED OFF
    smer = 2;
    }
    if (ServoMode == 3)
    {
    digitalWrite(MinusLed, LOW);  // turn LED OFF
    digitalWrite(PlusLed, LOW);  // turn LED OFF
    }

    if (RunStatus == 0 & val == 0)
    digitalWrite(RunLed, HIGH);  // turn LED OFF

    if (RunStatus == 0 & val != 0)
    digitalWrite(RunLed, HIGH);  // turn LED OFF

    if (RunStatus == 1 & ServoMode == 0)
    digitalWrite(RunLed, LOW);  // turn LED OFF

    if (RunStatus == 1 & ServoMode == 1)
    digitalWrite(RunLed, LOW);  // turn LED OFF

    if (RunStatus == 1 & ServoMode == 2)
    digitalWrite(RunLed, LOW);  // turn LED OFF

    if (RunStatus == 1 & ServoMode == 3)
    digitalWrite(RunLed, LOW);  // turn LED OFF

    
  Zmena = 0;  
  }
 }


 if (val < 0)
  digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)

 if (val >= 0)
  digitalWrite(LED_BUILTIN, LOW);   // turn the LED on (HIGH is the voltage level)

//      *****      ServoMode 0     *****

if (ServoMode == 0 & RunStatus == 1)
  {
  
   }
//      *****      koniec ServoMode 0     *****


//      *****      ServoMode 1     *****

if (ServoMode == 1 & RunStatus == 1)
  {
  
  if (smer == 1)
    val=val+Step;
  if (smer == 2)
    val=val-Step;

  if (val>= +100)
    {
      val = +100;
      smer = 2;

    }

  if (val<= -100)
    {
      val = -100;
      smer = 1;
    }
   }
//      *****      koniec ServoMode 1     *****


//      *****      ServoMode 2     *****

if (ServoMode == 2 & RunStatus == 1)
  {
  if (val ==100)
  delay (500);
  
  if (smer == 1)
    val=val+Step;
  if (smer == 2)
    val=val-Step;

  if (val>=+100)
    {
      val = +100;
      smer = 2;

    }

  if (val<-100)
    {
      val = 100;
      smer = 2;
    }
   }
//      *****      koniec ServoMode 2     *****

//      *****      ServoMode 3     *****

if (ServoMode == 3 & RunStatus == 1)
  {

  if ( AktualTime >=SSSCycle)
  {

  SSSCycle = AktualTime + SSSCycleDefault;
  
  if (smer == 1)
    val=val+100;
  if (smer == 2)
    val=val-100;

  if (val>= +100)
    {
      val = +100;
      smer = 2;

    }

  if (val<= -100)
    {
      val = -100;
      smer = 1;
    }

    }
   }
//      *****      koniec ServoMode 3     *****

//      *****      ukoncovanie pri STOPke     *****

  if ( val < 0 & RunStatus == 0 )
    {
    val++;
    if ( val == 0 )
      Zmena++;
    }

  if ( val > 0 & RunStatus == 0 )
    {
    val--;
    if ( val == 0 )
      Zmena++;
    }

//      *****      koniec ukoncovanie pri STOPke     *****


  outservo = val;
  outservo = map(val, -100, +100, 1000, 2000);     // scale it to use it with the servo (value between 0 and 180)
  myservo.writeMicroseconds(outservo);  // set servo to mid-point


  delay(20);                           // waits for the servo to get there
}
